Index: /trunk/anuga_core/source/anuga/coordinate_transforms/geo_reference.py
===================================================================
--- /trunk/anuga_core/source/anuga/coordinate_transforms/geo_reference.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/coordinate_transforms/geo_reference.py	(revision 7779)
@@ -11,5 +11,5 @@
 
 from anuga.utilities.numerical_tools import ensure_numeric
-from anuga.utilities.anuga_exceptions import ANUGAError, TitleError, \
+from anuga.anuga_exceptions import ANUGAError, TitleError, \
                                              ParsingError, ShapeError
 from anuga.config import netcdf_float, netcdf_int, netcdf_float32
Index: /trunk/anuga_core/source/anuga/coordinate_transforms/test_lat_long_UTM_conversion.py
===================================================================
--- /trunk/anuga_core/source/anuga/coordinate_transforms/test_lat_long_UTM_conversion.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/coordinate_transforms/test_lat_long_UTM_conversion.py	(revision 7779)
@@ -10,5 +10,5 @@
 from lat_long_UTM_conversion import *
 from redfearn import degminsec2decimal_degrees, decimal_degrees2degminsec
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
 
 import numpy as num
Index: /trunk/anuga_core/source/anuga/coordinate_transforms/test_redfearn.py
===================================================================
--- /trunk/anuga_core/source/anuga/coordinate_transforms/test_redfearn.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/coordinate_transforms/test_redfearn.py	(revision 7779)
@@ -9,5 +9,5 @@
 
 from redfearn import *
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
 
 from anuga.utilities.system_tools import get_pathname_from_package
Index: /trunk/anuga_core/source/anuga/culvert_flows/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga/culvert_flows/test_all.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/culvert_flows/test_all.py	(revision 7779)
@@ -181,5 +181,5 @@
     try:
         # importing something that loads quickly
-        import anuga.utilities.anuga_exceptions
+        import anuga.anuga_exceptions
     except ImportError:
         print "Python cannot import ANUGA module."
Index: /trunk/anuga_core/source/anuga/geospatial_data/geospatial_data.py
===================================================================
--- /trunk/anuga_core/source/anuga/geospatial_data/geospatial_data.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/geospatial_data/geospatial_data.py	(revision 7779)
@@ -22,5 +22,5 @@
 from anuga.coordinate_transforms.redfearn import convert_from_latlon_to_utm
 from anuga.utilities.system_tools import clean_line
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
 from anuga.config import points_file_block_line_size as MAX_READ_LINES
 from anuga.config import netcdf_mode_r, netcdf_mode_w, netcdf_mode_a
Index: /trunk/anuga_core/source/anuga/geospatial_data/test_geospatial_data.py
===================================================================
--- /trunk/anuga_core/source/anuga/geospatial_data/test_geospatial_data.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/geospatial_data/test_geospatial_data.py	(revision 7779)
@@ -11,5 +11,5 @@
 from anuga.coordinate_transforms.geo_reference import Geo_reference, TitleError
 from anuga.coordinate_transforms.redfearn import degminsec2decimal_degrees
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
 from anuga.utilities.system_tools import get_host_name
 from anuga.config import netcdf_mode_r, netcdf_mode_w, netcdf_mode_a
Index: /trunk/anuga_core/source/anuga/mesh_engine/mesh_engine.py
===================================================================
--- /trunk/anuga_core/source/anuga/mesh_engine/mesh_engine.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/mesh_engine/mesh_engine.py	(revision 7779)
@@ -14,5 +14,5 @@
 
 from anuga.utilities.numerical_tools import ensure_numeric
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
     
 def generate_mesh(points=None,
Index: /trunk/anuga_core/source/anuga/mesh_engine/test_generate_mesh.py
===================================================================
--- /trunk/anuga_core/source/anuga/mesh_engine/test_generate_mesh.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/mesh_engine/test_generate_mesh.py	(revision 7779)
@@ -16,5 +16,5 @@
 from anuga.utilities.numerical_tools import ensure_numeric
 
-from anuga.utilities.anuga_exceptions import ANUGAError
+from anuga.anuga_exceptions import ANUGAError
 
 class triangTestCase(unittest.TestCase):
Index: /trunk/anuga_core/source/anuga/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga/test_all.py	(revision 7778)
+++ /trunk/anuga_core/source/anuga/test_all.py	(revision 7779)
@@ -181,5 +181,5 @@
     try:
         # importing something that loads quickly
-        import anuga.utilities.anuga_exceptions
+        import anuga.anuga_exceptions
     except ImportError:
         print "Python cannot import ANUGA module."