Index: /anuga_validation/automated_validation_tests/UQ_runup_2006/run_dam.py
===================================================================
--- /anuga_validation/automated_validation_tests/UQ_runup_2006/run_dam.py	(revision 7794)
+++ /anuga_validation/automated_validation_tests/UQ_runup_2006/run_dam.py	(revision 7795)
@@ -17,6 +17,6 @@
 
 # Related major packages
-from anuga.shallow_water import Domain, Reflective_boundary, \
-     Dirichlet_boundary, Time_boundary, File_boundary
+import anuga
+
 from anuga.abstract_2d_finite_volumes.region import Set_region 
 from anuga.fit_interpolate.interpolate import interpolate_sww2csv, \
@@ -55,5 +55,5 @@
     # Setup computational domain
     #-------------------------------------------------------------------------
-    domain = Domain(project.mesh_filename, use_cache = False, verbose = False)
+    domain = anuga.Domain(project.mesh_filename, use_cache = False)
     domain.set_name(project.basename)
     domain.set_datadir('.')
@@ -80,6 +80,6 @@
                                  location = 'unique vertices') 
 
-    Br = Reflective_boundary(domain)
-    Bd = Dirichlet_boundary([0,0,0])  # to drain the water out.
+    Br = anuga.Reflective_boundary(domain)
+    Bd = anuga.Dirichlet_boundary([0,0,0])  # to drain the water out.
     domain.set_boundary( {'wall': Br, 'edge': Bd} )
 
Index: /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py
===================================================================
--- /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py	(revision 7794)
+++ /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py	(revision 7795)
@@ -72,8 +72,8 @@
                            } 
 
+
         # run trial, report on time and memory
         ben = BenchmarkLeastSquares()
-        (time, mem, num_tri, one_t,
-         more_t, quad_t) = ben.trial(num_of_points=1000,
+        (time, mem, num_tri, quad_t) = ben.trial(num_of_points=1000,
                                      maxArea=0.0001,
                                      is_fit=True,
Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py	(revision 7794)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py	(revision 7795)
@@ -22,8 +22,5 @@
 
 # Module imports
-from anuga.shallow_water import Domain
-from anuga.shallow_water import Reflective_boundary
-from anuga.shallow_water import Transmissive_momentum_set_stage_boundary
-from anuga.abstract_2d_finite_volumes.util import file_function
+import anuga
 
 import project
@@ -33,5 +30,5 @@
     # Create Domain from mesh
     #-------------------------
-    domain = Domain(project.mesh_filename, use_cache=False, verbose=True)
+    domain = anuga.Domain(project.mesh_filename, use_cache=False, verbose=True)
     print domain.statistics()
 
@@ -63,10 +60,10 @@
 
     # Create boundary function from timeseries provided in file
-    function = file_function(project.boundary_filename,
+    function = anuga.file_function(project.boundary_filename,
                              domain, verbose=True)
 
     # Create and assign boundary objects
-    Bts = Transmissive_momentum_set_stage_boundary(domain, function)
-    Br = Reflective_boundary(domain)
+    Bts = anuga.Transmissive_momentum_set_stage_boundary(domain, function)
+    Br = anuga.Reflective_boundary(domain)
     domain.set_boundary({'wave': Bts, 'wall': Br})
 
Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/test_caching_of_set_quantity.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/test_caching_of_set_quantity.py	(revision 7794)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/test_caching_of_set_quantity.py	(revision 7795)
@@ -9,5 +9,5 @@
 
 # Module imports
-from anuga.shallow_water import Domain
+from anuga.shallow_water.shallow_water_domain import Domain
 from anuga.caching import cache
 from anuga.fit_interpolate.fit import _fit_to_mesh
Index: /anuga_validation/automated_validation_tests/patong_beach_validation/run_model.py
===================================================================
--- /anuga_validation/automated_validation_tests/patong_beach_validation/run_model.py	(revision 7794)
+++ /anuga_validation/automated_validation_tests/patong_beach_validation/run_model.py	(revision 7795)
@@ -29,17 +29,6 @@
 from Scientific.IO.NetCDF import NetCDFFile
 
-from anuga.interface import create_domain_from_regions
-from anuga.interface import Transmissive_stage_zero_momentum_boundary
-from anuga.interface import Dirichlet_boundary
-from anuga.interface import Reflective_boundary
-from anuga.interface import Field_boundary
-from anuga.interface import create_sts_boundary
-from anuga.interface import csv2building_polygons
-from anuga.utilities.system_tools import file_length
-
-from anuga.utilities.file_utils import copy_code_files
-from anuga.shallow_water.data_manager import urs2sts
-from anuga.utilities.polygon import read_polygon, Polygon_function
-from anuga.caching import cache
+import anuga
+
 
 import project
Index: /anuga_validation/circular_island/run_circular.py
===================================================================
--- /anuga_validation/circular_island/run_circular.py	(revision 7794)
+++ /anuga_validation/circular_island/run_circular.py	(revision 7795)
@@ -8,10 +8,10 @@
 
 # Module imports
-from anuga.shallow_water import Domain
+from anuga.shallow_water.shallow_water_domain import Domain
 from anuga.shallow_water import Reflective_boundary
 from anuga.shallow_water import Transmissive_momentum_set_stage_boundary
 from anuga.shallow_water import Dirichlet_boundary, Time_boundary
 from anuga.utilities.file_utils import copy_code_files
-from anuga.shallow_water.data_manager import get_maximum_inundation_data
+from anuga.shallow_water.sww_interrogate import get_maximum_inundation_data
 from anuga.abstract_2d_finite_volumes.util import file_function, \
                             sww2csv_gauges, csv2timeseries_graphs
Index: /anuga_validation/uq_flume_2007/run_dam.py
===================================================================
--- /anuga_validation/uq_flume_2007/run_dam.py	(revision 7794)
+++ /anuga_validation/uq_flume_2007/run_dam.py	(revision 7795)
@@ -22,5 +22,5 @@
 
 # Related major packages
-from anuga.shallow_water import Domain, Reflective_boundary, \
+from anuga.shallow_water.shallow_water_domain import Domain, Reflective_boundary, \
                             Dirichlet_boundary, Time_boundary, File_boundary
 from anuga.abstract_2d_finite_volumes.region import Set_region 