Index: /anuga_validation/automated_validation_tests/urs_mux_files_validation/run_Bf.py
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/run_Bf.py	(revision 7797)
+++ /anuga_validation/automated_validation_tests/urs_mux_files_validation/run_Bf.py	(revision 7798)
@@ -14,15 +14,15 @@
 # Standard modules
 from os import sep,getcwd, access, F_OK, mkdir, getenv
-from os.path import dirname, basename,abspath 
+from os.path import dirname, basename, abspath 
 from shutil import copy
 import time, sys, os, tempfile
 
 # Related major packages
-from anuga.shallow_water import Domain,Dirichlet_boundary,File_boundary,Transmissive_boundary, Field_boundary
+import anuga
 import numpy as num
-from anuga.pmesh.mesh_interface import create_mesh_from_regions
-from anuga.utilities.file_utils import copy_code_files
-from anuga.abstract_2d_finite_volumes.util import sww2timeseries, get_data_from_file
+
+
 # Application specific imports
+import anuga.file.csv_file as csv_file
 
 #------------------------------------------------------------------------------
@@ -47,5 +47,5 @@
 # N, W, S, E
 
-create_mesh_from_regions(all,
+anuga.create_mesh_from_regions(all,
                              boundary_tags={'ocean': [ 0],'side': [1, 3], 'back': [2]},
                              maximum_triangle_area=50000,
@@ -58,11 +58,10 @@
 #-------------------------------------------------------------------------
 #print 'Setup computational domain'
-domain = Domain( meshes_dir_name, verbose=True)
-
-from anuga.shallow_water.data_manager import urs2sww
+domain = anuga.Domain( meshes_dir_name, verbose=True)
+
 boundaries_dir_name = 'o_test'
 
 # convert MUX urs files to an SWW file output
-urs2sww(boundaries_dir_name,boundaries_dir_name,
+anuga.urs2sww(boundaries_dir_name,boundaries_dir_name,
            mint=9200, maxt= 11200,
            fail_on_NaN= False,
@@ -91,10 +90,10 @@
 # Setup boundary conditions 
 #-------------------------------------------------------------------------
-Bf = Field_boundary(out_dir + 'o_test.sww',
+Bf = anuga.Field_boundary(out_dir + 'o_test.sww',
                   domain, mean_stage=tide, use_cache=True, verbose=False)
 
 #Br = Reflective_boundary(domain)
-Bt = Transmissive_boundary(domain)
-Bd = Dirichlet_boundary([tide,0,0])
+Bt = anuga.Transmissive_boundary(domain)
+Bd = anuga.Dirichlet_boundary([tide,0,0])
 
 
@@ -150,5 +149,5 @@
 #get timeseries data from evolved sww file        
 #----------------------------------------------------------------------------
-texname, elev_output = sww2timeseries(swwfiles,
+texname, elev_output = anuga.sww2timeseries(swwfiles,
                                       out_dir+sep+"gauges.txt",
 #                                      out_dir+sep+"gauges.csv",
@@ -171,5 +170,5 @@
 #get timeseries data from boundary sww file        
 #----------------------------------------------------------------------------
-texname, elev_output = sww2timeseries(swwfiles,
+texname, elev_output = anuga.sww2timeseries(swwfiles,
                                       out_dir+sep+"boundary_gauges.txt",
 #                                      out_dir+sep+"boundary_gauges.csv",
@@ -189,12 +188,12 @@
 #----------------------------------------------------------------------------
 
-e_header, e_data = get_data_from_file(evolved_dir_filename)
+e_data = csv_file.load_csv_as_array(evolved_dir_filename)
 
 # assign columns from array to single vector(arrays)
-e_time = e_data[:,0]
-e_stage = e_data[:,1]
-e_momentum = e_data[:,2]
-e_speed = e_data[:,3]
-e_elevation = e_data[:,4]
+e_time = e_data['Time']
+e_stage = e_data['Stage']
+e_momentum = e_data['Momentum']
+e_speed = e_data['Speed']
+e_elevation = e_data['Elevation']
 
 #----------------------------------------------------------------------------
@@ -203,12 +202,12 @@
 #----------------------------------------------------------------------------
 
-b_header, b_data = get_data_from_file(boundary_dir_filename)
+b_data = csv_file.load_csv_as_array(boundary_dir_filename)
 
 # assign columns from array to single vector(arrays)
-b_time = b_data[:,0]
-b_stage = b_data[:,1]
-b_momentum = b_data[:,2]
-b_speed = b_data[:,3]
-b_elevation = b_data[:,4]
+b_time = b_data['Time']
+b_stage = b_data['Stage']
+b_momentum = b_data['Momentum']
+b_speed = b_data['Speed']
+b_elevation = b_data['Elevation']
 
 #----------------------------------------------------------------------------