Index: trunk/anuga_core/documentation/user_manual/examples/bedslope.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/examples/bedslope.py	(revision 7807)
+++ 	(revision )
@@ -1,58 +1,0 @@
-"""Simple example of shallow water wave equation using Pyvolution
-
-Water driven by linear slope and Dirichlet boundary
-
-"""
-
-######################
-# Module imports 
-#
-from anuga.pyvolution.mesh_factory import rectangular
-from anuga.pyvolution.shallow_water import Domain, Reflective_boundary,\
-     Dirichlet_boundary, Time_boundary, Transmissive_boundary
-
-#Create basic triangular mesh
-points, vertices, boundary = rectangular(2, 1)
-
-#Create shallow water domain
-domain = Domain(points, vertices, boundary)
-domain.set_name('bedslope')
-domain.set_datadir('.')                      #Use current directory for output
-domain.set_quantities_to_be_stored('stage')  #See shallow_water.py
-
-
-#######################
-# Initial conditions
-def f(x,y):
-    return -x/2
-
-domain.set_quantity('elevation', f)
-domain.set_quantity('friction', 0.1)
-
-h = 0.05  # Constant depth
-domain.set_quantity('stage', expression = 'elevation + %f' %h)
-
-
-######################
-# Boundary conditions
-from math import sin, pi
-Br = Reflective_boundary(domain)
-Bt = Transmissive_boundary(domain)
-Bd = Dirichlet_boundary([0.2,0.,0.])
-Bw = Time_boundary(domain=domain,
-                   f=lambda t: [(0.1*sin(t*2*pi)), 0.0, 0.0])
-
-
-print 'Tags are ', domain.get_boundary_tags()
-
-domain.set_boundary({'left': Bd, 'right': Br, 'top': Br, 'bottom': Br})
-#domain.set_boundary({'left': Bw, 'right': Br, 'top': Br, 'bottom': Br})
-
-
-######################
-#Evolution
-domain.check_integrity()
-
-for t in domain.evolve(yieldstep = 0.1, finaltime = 0.2):
-    domain.write_time()
-
Index: trunk/anuga_core/documentation/user_manual/examples/harbour.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/examples/harbour.py	(revision 7807)
+++ trunk/anuga_core/documentation/user_manual/examples/harbour.py	(revision 7808)
@@ -14,11 +14,5 @@
 # Import necessary modules
 #------------------------------------------------------------------------------
-
-from anuga.pmesh.mesh_interface import create_mesh_from_regions
-from anuga.shallow_water import Domain
-from anuga.shallow_water import Reflective_boundary
-from anuga.shallow_water import Dirichlet_boundary
-from anuga.shallow_water import Time_boundary
-from anuga.shallow_water import Transmissive_boundary
+import anuga
 
 waveheight = 1.0
@@ -41,5 +35,5 @@
 meshname = 'harbour_test.msh'
 
-create_mesh_from_regions(polygon,
+anuga.create_mesh_from_regions(polygon,
                          boundary_tags={'top': [0],
                                         'left': [1],
@@ -50,5 +44,5 @@
                          #interior_regions=interior_regions)
 
-domain = Domain(meshname,use_cache=True,verbose = True)
+domain = anuga.Domain(meshname,use_cache=True,verbose = True)
 domain.set_name('harbour')                  # Output to harbour.sww
 domain.set_datadir('.')                     # Use current directory for output
@@ -65,6 +59,6 @@
 
 def topography(x,y):
-    from Numeric import zeros, Float
-    z = zeros(len(x), Float)
+    from numpy import zeros, float
+    z = zeros(len(x), float)
     
     xcentre = (west+east)/2.
@@ -92,8 +86,8 @@
 
 from math import sin, pi
-Br = Reflective_boundary(domain)      # Solid reflective wall
-Bt = Transmissive_boundary(domain)    # Continue all values on boundary 
-Bd = Dirichlet_boundary([0.,0.,0.])   # Constant boundary values
-Bw = Time_boundary(domain=domain,     # Time dependent boundary  
+Br = anuga.Reflective_boundary(domain)      # Solid reflective wall
+Bt = anuga.Transmissive_boundary(domain)    # Continue all values on boundary 
+Bd = anuga.Dirichlet_boundary([0.,0.,0.])   # Constant boundary values
+Bw = anuga.Time_boundary(domain=domain,     # Time dependent boundary  
                    f=lambda t: [((10<t<20)*waveheight), 0.0, 0.0])
 
@@ -115,5 +109,5 @@
 # Gauge line
 def gauge_line(west,east,north,south):
-    from Numeric import arange
+    from numpy import arange
     gaugex = arange(east,west,-1000.)
     gauges = []
@@ -127,7 +121,5 @@
 gauges, gaugex, gaugey = gauge_line(west,east,north,south)
 
-from anuga.abstract_2d_finite_volumes.util import file_function
-
-f = file_function('harbour.sww',
+f = anuga.file_function('harbour.sww',
                   quantities = ['stage', 'elevation', 'xmomentum', 'ymomentum'],
                   interpolation_points = gauges,
Index: trunk/anuga_core/documentation/user_manual/examples/project.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/examples/project.py	(revision 7807)
+++ trunk/anuga_core/documentation/user_manual/examples/project.py	(revision 7808)
@@ -56,5 +56,5 @@
 demopoly = [j0, j1, j2, j3, j31, j4, j5, j6, j7]
 
-from anuga.utilities.polygon import read_polygon, plot_polygons
+from anuga.geometry.polygon import read_polygon, plot_polygons
 #polygonptsfile4 = polygondir + 'poly1'
 #polygonptsfile0 = polygondir + 'poly2'
Index: trunk/anuga_core/documentation/user_manual/examples/runsydney.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/examples/runsydney.py	(revision 7807)
+++ trunk/anuga_core/documentation/user_manual/examples/runsydney.py	(revision 7808)
@@ -20,12 +20,8 @@
 
 # Related major packages
-from anuga.shallow_water import Domain, Dirichlet_boundary
-from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
-from anuga.abstract_2d_finite_volumes.combine_pts import combine_rectangular_points_files 
-from anuga.pmesh.mesh_interface import create_mesh_from_regions
+import anuga
 
 # Application specific imports
 import project                           # Define file names and polygons
-from anuga.shallow_water.smf import slump_tsunami # Function for submarine mudslide 
 
 
@@ -41,14 +37,8 @@
 meshname = project.meshname+'.msh'
 
-convert_dem_from_ascii2netcdf(demname, use_cache=True, verbose=True)
+anuga.asc2dem(demname, use_cache=True, verbose=True)
 
 # creates pts file 
-dem2pts(demname, use_cache=True, verbose=True)
-
-# combining the coarse and fine data
-#combine_rectangular_points_files(finedemname,
-#                                 coarsedemname,
-#                                 combineddemname)
-
+anuga.dem2pts(demname, use_cache=True, verbose=True)
 
 
@@ -68,5 +58,5 @@
                     [project.shallow_polygon, shallow_res]]
 
-create_mesh_from_regions(project.demopoly,
+anuga.create_mesh_from_regions(project.demopoly,
                          boundary_tags= {'oceannorth': [0], 
                                          'onshorenorth1': [1],
@@ -85,5 +75,5 @@
 #Create shallow water domain
 
-domain = Domain(meshname,
+domain = anuga.Domain(meshname,
                 use_cache = True,
                 verbose = True)                                  
@@ -102,5 +92,5 @@
 #------------------------------------------------------------------------------
 
-tsunami_source = slump_tsunami(length=30000.0,
+tsunami_source = anuga.slump_tsunami(length=30000.0,
                                depth=400.0,
                                slope=6.0,
@@ -131,5 +121,5 @@
 print 'Available boundary tags', domain.get_boundary_tags()
 
-Bd = Dirichlet_boundary([0.0,0.0,0.0])
+Bd = anuga.Dirichlet_boundary([0.0,0.0,0.0])
 domain.set_boundary( {'oceannorth': Bd,
                       'onshorenorth1': Bd,
Index: trunk/anuga_core/documentation/user_manual/examples/runuptest.py
===================================================================
--- trunk/anuga_core/documentation/user_manual/examples/runuptest.py	(revision 7807)
+++ trunk/anuga_core/documentation/user_manual/examples/runuptest.py	(revision 7808)
@@ -10,10 +10,5 @@
 #------------------------------------------------------------------------------
 
-from anuga.pmesh.mesh_interface import create_mesh_from_regions
-from anuga.shallow_water import Domain
-from anuga.shallow_water import Reflective_boundary
-from anuga.shallow_water import Dirichlet_boundary
-from anuga.shallow_water import Time_boundary
-from anuga.shallow_water import Transmissive_boundary
+import anuga
 
 
@@ -32,5 +27,5 @@
 meshname = 'test.msh'
 
-create_mesh_from_regions(polygon,
+anuga.create_mesh_from_regions(polygon,
                          boundary_tags={'top': [0],
                                         'left': [1],
@@ -41,5 +36,5 @@
                          #interior_regions=interior_regions)
 
-domain = Domain(meshname,use_cache=True,verbose = True)
+domain = anuga.Domain(meshname,use_cache=True,verbose = True)
 domain.set_name('test')                     # Output to test.sww
 domain.set_datadir('.')                     # Use current directory for output
@@ -67,8 +62,8 @@
 
 from math import sin, pi
-Br = Reflective_boundary(domain)      # Solid reflective wall
-Bt = Transmissive_boundary(domain)    # Continue all values on boundary 
-Bd = Dirichlet_boundary([0.,0.,0.])   # Constant boundary values
-Bw = Time_boundary(domain=domain,     # Time dependent boundary  
+Br = anuga.Reflective_boundary(domain)      # Solid reflective wall
+Bt = anuga.Transmissive_boundary(domain)    # Continue all values on boundary 
+Bd = anuga.Dirichlet_boundary([0.,0.,0.])   # Constant boundary values
+Bw = anuga.Time_boundary(domain=domain,     # Time dependent boundary  
                    f=lambda t: [((10<t<20)*waveheight), 0.0, 0.0])
 
@@ -91,5 +86,5 @@
 # Gauge line
 def gauge_line(west,east,north,south):
-    from Numeric import arange
+    from numpy import arange
     gaugex = arange(west,(west+east)/2.,1000.)
     gauges = []
@@ -103,7 +98,5 @@
 gauges, gaugex, gaugey = gauge_line(west,east,north,south)
 
-from anuga.abstract_2d_finite_volumes.util import file_function
-
-f = file_function('test.sww',
+f = anuga.file_function('test.sww',
                   quantities = ['stage', 'elevation', 'xmomentum', 'ymomentum'],
                   interpolation_points = gauges,